(in-package asdf)
			 

(asdf:defsystem "angelic"
    :components ((:module "misc" :pathname "misc/" :serial t
			  :components
			  ((:file "package-utils")
			   (:file "util-pkg")
			   (:file "macros")
			   (:file "clone")
			   (:file "same")
			   (:file "canonicalize" :depends-on ("clone"))
			   (:file "hash-table-array" :depends-on ("canonicalize"))
			   (:file "cluster")
			   (:file "help")
			   (:file "utils" :depends-on ("clone"))
			   (:file "array-utils" :depends-on ("utils" "macros"))
			   (:file "list-utils" :depends-on ("utils"))
			   (:file "function-utils")
			   (:file "exp-utils")
			   (:file "matlab" :depends-on ("utils"))
			   (:file "sequence-utils" :depends-on ("utils"))
			   (:file "string-utils" :depends-on ("sequence-utils"))
			   ))
		 
		 (:module "set" :pathname "data-struct/set/"
			  :depends-on ("misc")
			  :components ((:file "set")
				       (:file "seq-set" :depends-on ("set"))
				       (:file "hash-set" :depends-on ("set"))
				       (:file "number-set" :depends-on ("set"))
				       (:file "indexed-set" :depends-on ("set"))
				       (:file "recursive-enumeration" :depends-on ("set"))
				       (:file "named-sets" :depends-on ("set"))
				       (:file "inst-var-accessors" :depends-on ("set"))
				       (:file "create-sets" :depends-on ("set" "indexed-set"))
				       (:file "directory-set" :depends-on ("set"))
				       (:file "direct-product-set" :depends-on ("set"))))
		 

		 (:module "data-struct" :pathname "data-struct/"
			  :depends-on ("misc" "prob" "set")
			  :components
			  ((:file "bucketed-counts")
			   (:file "mapping")
			   (:file "circular-vector")
			   (:file "local-search")
			   (:file "queue")
			   (:file "graph")
			   (:module "bnet"
				    :depends-on ("graph")
				    :components ((:file "bnet-pkg")
						 (:file "2tbn" :depends-on ("bnet-pkg"))))
			   (:module "tree"
				    :components ((:file "tree")
						 (:file "tree-set" :depends-on ("tree"))))
			   
			   (:module "prop-logic" :depends-on ("mapping" "tree")
				    :components ((:file "prop-formula")
						 (:file "dnf" :depends-on ("prop-formula"))
						 (:file "dnf-set" :depends-on ("dnf"))))
			   
 			   (:module "pot-set"
 				    :components ((:file "pot-pkg")
						 (:file "operation" :depends-on ("pot-pkg"))
 						 (:file "potential" :depends-on ("pot-pkg"))
 						 (:file "tabular-potential" :depends-on ("potential"))
 						 (:file "function-potential" :depends-on ("potential"))
						 (:file "number-potential" :depends-on ("potential"))
					 	 (:file "pot-set" :depends-on ("potential" "operation"))
						 (:file "undirected-graphical-model" :depends-on ("pot-set"))
						 ))

			   (:file "cache")
			   ))
		 
		 
		 (:module "env" :depends-on ("misc" "set" "prob")
			  :components ((:file "env-pkg")
				       (:file "env" :depends-on ("env-pkg"))
				       (:file "fully-observable-env" :depends-on ("env"))
				       ))
		 
		 (:module "prob"
			  :depends-on ("set")
			  :components ((:file "probability-distribution")
				       (:file "function-random-variable" :depends-on ("probability-distribution"))
				       (:file "create-distributions" :depends-on ("probability-distribution"))
				       (:file "vector-probability-distribution" :depends-on ("probability-distribution"))
				       (:file "hash-table-prob-dist" :depends-on ("probability-distribution"))
				       (:file "alist-probability-distribution" :depends-on ("probability-distribution"))))

	
		 (:module "lookahead" :depends-on ("misc" "prob" "env" "set" "data-struct")
			  :components
			  ((:file "lookahead")
			   (:file "planning-problem" :depends-on ("lookahead"))
			   (:file "hierarchy" :depends-on ("lookahead" "planning-problem"))
			   (:file "description" :depends-on ("lookahead"))
			   (:file "abstract-planning-problem" :depends-on ("planning-problem" "hierarchy"))
			   (:module "prop"
				    :depends-on ("lookahead")
				    :components
				    ((:file "prop-set")
				     (:file "csp")
				     (:file "prop-domain" :depends-on ("csp"))
				     (:file "ncstrips" :depends-on ("prop-set" "prop-domain"))
				     (:file "prop-hierarchy" :depends-on ("prop-domain"))
				     (:file "prop-abstract-planning-problem" :depends-on ("prop-domain"))))))
					    
		 (:module "envs" :depends-on ("lookahead")
			  :components
			  ((:module "blocks"
				    :components ((:file "blocks-ceiling")
						 (:file "hierarchy" :depends-on ("blocks-ceiling"))
						 (:file "descriptions" :depends-on ("blocks-ceiling"))))))))