(in-package blocks)

(defun make-complete-descriptions (d)
  (make-ncstrips-schemas d
    (nav-right 
     :var-domains ((?xs columns) (?xt columns) (?y rows))
     :effects ((:precond 
		(and (gripper-pos ?xs ?y) (right-of ?xt ?xs) (free ?xt ?y))
		:poss-add-list ((gripper-pos ?xt ?y))
		:poss-delete-list ((gripper-pos ?xs ?y)))))
    
    (nav-left 
     :var-domains ((?xs columns) (?xt columns) (?y rows))
     :effects ((:precond 
		(and (gripper-pos ?xs ?y) (right-of ?xs ?xt) (free ?xt ?y))
		:poss-add-list ((gripper-pos ?xt ?y) (for-all ((?x columns)) (xbetween ?xt ?x ?xs)
									    (gripper-pos ?x ?y)))
		:poss-delete-list ((gripper-pos ?xs ?y) (for-all ((?x columns)) (xbetween ?xt ?x ?xs)
									       (free ?x ?y))))))
    
    (nav-up
     :var-domains ((?x columns) (?ys rows) (?yt rows))
     :effects ((:precond 
		(and (gripper-pos ?x ?ys) (above ?yt ?ys) (free ?x ?yt))
		:poss-add-list ((gripper-pos ?x ?yt) )
		:poss-delete-list ((gripper-pos ?x ?ys) ))))
    
    (nav-down
     :var-domains ((?x columns) (?ys rows) (?yt rows))
     :effects ((:precond 
		(and (gripper-pos ?x ?ys) (above ?ys ?yt) (free ?x ?yt))
		:poss-add-list ((gripper-pos ?x ?yt) )
		:poss-delete-list ((gripper-pos ?x ?ys) ))))

    (navigate
     :var-domains ((?xs columns) (?ys rows) (?xt columns) (?yt rows))
     :effects ((:precond
		(and (gripper-pos ?xs ?ys) (free ?xt ?yt))
		:poss-add-list ((gripper-pos ?xt ?yt) (faceR) (faceL) )
		:poss-delete-list ((gripper-pos ?xs ?ys) (faceR) (faceL)))))
    
    (nav 
     :var-domains ((?xs columns) (?ys rows) (?xt columns) (?yt rows))
     :effects ((:precond
		(and (gripper-pos ?xs ?ys) (free ?xt ?yt))
		:poss-add-list ((gripper-pos ?xt ?yt))
		:poss-delete-list ((gripper-pos ?xs ?ys)))))
     
    (move-block
     :var-domains ((?b actual-blocks) (?a blocks) (?c blocks) (?xb columns) (?yb rows)
				      (?xc columns) (?yc all-rows) (?yt rows))
     :effects ((:precond 
		(and (clear ?b) (clear ?c) (on ?b ?a))
		:delete-list ((on ?b ?a) (clear ?c) (block-pos ?b ?xb ?yb) (free ?xc ?yt))
		:poss-delete-list ((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y)) )
		:poss-add-list ((for-all ((?x columns)) (or (r ?x ?xc) (r ?xc ?x)) (gripper-pos ?x ?yt)) )
		:add-list ((on ?b ?c) (clear ?a) (block-pos ?b ?xc ?yt) (free ?xb ?yb)))))
    ))



(defun make-sound-descriptions (d)
  (make-ncstrips-schemas d
    (nav-right 
     :var-domains ((?xs columns) (?xt columns) (?y rows))
     :effects ((:precond 
		(and (gripper-pos ?xs ?y) (int= ?xt ?xs) ))
	       (:precond 
		(and (gripper-pos ?xs ?y) (right-of ?xt ?xs) (for-all (?x columns) (free ?x ?y)))
		:add-list ((gripper-pos ?xt ?y))
		:delete-list ((gripper-pos ?xs ?y)))))
    (nav-left
     :var-domains ((?xs columns) (?xt columns) (?y rows))
     :effects ((:precond 
		(and (gripper-pos ?xs ?y) (int= ?xs ?xt) ))
	       (:precond 
		(and (gripper-pos ?xs ?y) (right-of ?xs ?xt) (for-all (?x columns) (free ?x ?y)))
		:add-list ((gripper-pos ?xt ?y))
		:delete-list ((gripper-pos ?xs ?y)))))
    (nav-up 
     :var-domains ((?x columns) (?ys rows) (?yt rows))
     :effects ((:precond 
		(and (gripper-pos ?x ?ys) (int= ?yt ?ys) ))
	       (:precond 
		(and (gripper-pos ?x ?ys) (above ?yt ?ys) (for-all (?y rows) (free ?x ?y)))
		:add-list ((gripper-pos ?x ?yt))
		:delete-list ((gripper-pos ?x ?ys)))))
    
    (nav-down 
     :var-domains ((?x columns) (?ys rows) (?yt rows))
     :effects ((:precond 
		(and (gripper-pos ?x ?ys) (int= ?ys ?yt) ))
	       (:precond 
		(and (gripper-pos ?x ?ys) (above ?ys ?yt) (for-all (?y rows) (free ?x ?y)))
		:add-list ((gripper-pos ?x ?yt))
		:delete-list ((gripper-pos ?x ?ys)))))
    
    (navigate
     :var-domains ((?xs columns) (?ys rows) (?xt columns) (?yt rows))
     :effects ((:precond
		(and (gripper-pos ?xs ?ys) (int= ?xs ?xt) (int= ?ys ?yt))
		:poss-add-list ((facer) (facel))
		:poss-delete-list ((facer) (facel))
		:add-list nil :delete-list nil)
	       (:precond
		(and (gripper-pos ?xs ?ys) (free ?xt ?yt) (for-all (?x columns) (free ?x (1- (num-rows d)))))
		:poss-add-list ((facer) (facel))
		:poss-delete-list ((facer) (facel))
		:add-list ((gripper-pos ?xt ?yt))
		:delete-list ((gripper-pos ?xs ?ys)))))
    
    (nav
     :var-domains ((?xs columns) (?ys rows) (?xt columns) (?yt rows))
     :effects ((:precond
		(and (gripper-pos ?xs ?ys) (int= ?xs ?xt) (int= ?ys ?yt))
		:add-list nil :delete-list nil)
	       (:precond
		(and (gripper-pos ?xs ?ys) (free ?xt ?yt) (for-all (?x columns) (free ?x (1- (num-rows d)))))
		:add-list ((gripper-pos ?xt ?yt))
		:delete-list ((gripper-pos ?xs ?ys)))))
    (move-block
     :var-domains ((?b actual-blocks) (?a blocks) (?c blocks) (?xb columns) (?yb rows)
				      (?xc columns) (?yc all-rows) (?yt rows))
     :effects nil
     )
    ))




(defun make-dummy-complete-descriptions (d)
  (make-ncstrips-schemas d
    (nav-right 
     :var-domains ((?xs columns) (?xt columns) (?y rows))
     :effects ((:precond 
		(and)
		:poss-add-list ((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
				(for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
				(for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
				(for-all ((?x columns) (?y rows)) t (free ?x ?y))
				(for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
				(for-all ((?c gripper-contents)) t (gripper-holding ?c)))
					 
		:poss-delete-list 
		((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
		 (for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
		 (for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
		 (for-all ((?x columns) (?y rows)) t (free ?x ?y))
		 (for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
		 (for-all ((?c gripper-contents)) t (gripper-holding ?c))))))
					 
		
    
    (nav-left 
     :var-domains ((?xs columns) (?xt columns) (?y rows))
     :effects ((:precond 
		(and)
		:poss-add-list ((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
				(for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
				(for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
				(for-all ((?x columns) (?y rows)) t (free ?x ?y))
				(for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
				(for-all ((?c gripper-contents)) t (gripper-holding ?c)))
					 
		:poss-delete-list 
		((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
		 (for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
		 (for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
		 (for-all ((?x columns) (?y rows)) t (free ?x ?y))
		 (for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
		 (for-all ((?c gripper-contents)) t (gripper-holding ?c))))))
    
    (nav-up
     :var-domains ((?x columns) (?ys rows) (?yt rows))
     :effects ((:precond 
		(and)
		:poss-add-list ((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
				(for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
				(for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
				(for-all ((?x columns) (?y rows)) t (free ?x ?y))
				(for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
				(for-all ((?c gripper-contents)) t (gripper-holding ?c)))
					 
		:poss-delete-list 
		((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
		 (for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
		 (for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
		 (for-all ((?x columns) (?y rows)) t (free ?x ?y))
		 (for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
		 (for-all ((?c gripper-contents)) t (gripper-holding ?c))))))
    
    (nav-down
     :var-domains ((?x columns) (?ys rows) (?yt rows))
     :effects ((:precond 
		(and)
		:poss-add-list ((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
				(for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
				(for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
				(for-all ((?x columns) (?y rows)) t (free ?x ?y))
				(for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
				(for-all ((?c gripper-contents)) t (gripper-holding ?c)))
					 
		:poss-delete-list 
		((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
		 (for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
		 (for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
		 (for-all ((?x columns) (?y rows)) t (free ?x ?y))
		 (for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
		 (for-all ((?c gripper-contents)) t (gripper-holding ?c))))))

    (navigate
     :var-domains ((?xs columns) (?ys rows) (?xt columns) (?yt rows))
     :effects ((:precond 
		(and)
		:poss-add-list ((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
				(for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
				(for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
				(for-all ((?x columns) (?y rows)) t (free ?x ?y))
				(for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
				(for-all ((?c gripper-contents)) t (gripper-holding ?c)))
					 
		:poss-delete-list 
		((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
		 (for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
		 (for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
		 (for-all ((?x columns) (?y rows)) t (free ?x ?y))
		 (for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
		 (for-all ((?c gripper-contents)) t (gripper-holding ?c))))))
    
    (nav
     :var-domains ((?xs columns) (?ys rows) (?xt columns) (?yt rows))
     :effects ((:precond 
		(and)
		:poss-add-list ((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
				(for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
				(for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
				(for-all ((?x columns) (?y rows)) t (free ?x ?y))
				(for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
				(for-all ((?c gripper-contents)) t (gripper-holding ?c)))
					 
		:poss-delete-list 
		((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
		 (for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
		 (for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
		 (for-all ((?x columns) (?y rows)) t (free ?x ?y))
		 (for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
		 (for-all ((?c gripper-contents)) t (gripper-holding ?c))))))
     
    (move-block
     :var-domains ((?b actual-blocks) (?a blocks) (?c blocks) (?xb columns) (?yb rows)
				      (?xc columns) (?yc all-rows) (?yt rows))
     :effects ((:precond 
		(and)
		:poss-add-list ((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
				(for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
				(for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
				(for-all ((?x columns) (?y rows)) t (free ?x ?y))
				(for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
				(for-all ((?c gripper-contents)) t (gripper-holding ?c)))
					 
		:poss-delete-list 
		((for-all ((?x columns) (?y rows)) t (gripper-pos ?x ?y))
		 (for-all ((?b blocks) (?x columns) (?y rows)) t (block-pos ?b ?x ?y))
		 (for-all ((?b blocks) (?c blocks)) t (on ?b ?c))
		 (for-all ((?x columns) (?y rows)) t (free ?x ?y))
		 (for-all ((?b blocks)) t (clear ?b)) (facer) (facel)
		 (for-all ((?c gripper-contents)) t (gripper-holding ?c))))))
    ))
    
(defun make-dummy-sound-descriptions (d)
  (make-ncstrips-schemas d
    (nav-right 
     :var-domains ((?xs columns) (?xt columns) (?y rows))
     :effects ())
    (nav-left
     :var-domains ((?xs columns) (?xt columns) (?y rows))
     :effects ())
    (nav-up 
     :var-domains ((?x columns) (?ys rows) (?yt rows))
     :effects ()
     )
    
    (nav-down 
     :var-domains ((?x columns) (?ys rows) (?yt rows))
     :effects ())
    
    (navigate
     :var-domains ((?xs columns) (?ys rows) (?xt columns) (?yt rows))
     :effects ()
     )
    
    (nav
     :var-domains ((?xs columns) (?ys rows) (?xt columns) (?yt rows))
     :effects ()
     )
    (move-block
     :var-domains ((?b actual-blocks) (?a blocks) (?c blocks) (?xb columns) (?yb rows)
				      (?xc columns) (?yc all-rows) (?yt rows))
     :effects nil
     )
    ))     
     
