(in-package cl-user)

(defpackage lookahead
  (:documentation "Package lookahead (hla)
Planning problems
-----------------
action-result
goal
goal?
init-state
action-seq-result
succeeds?
all-actions
init-state-set
<propositional-domain>
propositions
prop-domain-state
pds-props
pds-domain
lookup-type
fluents
nonfluents



Hierarchies
-----------
action-type
refinements
high-level
primitive
unknown-action
product

Abstract planning problem
-------------------------
<abstract-planning-problem>
<prop-abstract-planning-problem>
hierarchical-forward-search
*refinement-set-type*

Abstract action descriptions
----------------------------
successor-set

Propositional planning problems
-------------------------------
Nondeterministic conditional STRIPS
-----------------------------------
strips
make-strips
make-strips-schema
nstrips
make-nstrips
*nstrips-noop*
ncstrips
make-ncstrips
make-ncstrips-schema
make-ncstrips-schemas
for-all

Parameters
----------
*random-refinement-ordering*

Other symbols
-------------
high-level
primitive

")

  (:use cl
	utils
	set
	prod-set
	create-env
	mapping
	prop-logic
	tree)
  (:nicknames hla)
  (:export

   action-result
   goal
   goal?
   init-state
   init-state-set
   action-seq-result
   all-actions
   succeeds?
   <propositional-domain>
   propositions
   prop-domain-state
   pds-props
   pds-domain
   lookup-type
   fluents
   non-fluents
   
   <hierarchy>
   <prop-hierarchy>
   make-implementation
   make-hla-schema
   action-type
   refinements
   high-level
   primitive
   unknown-action
   product
   
   <abstract-planning-problem>
   <prop-abstract-planning-problem>
   hierarchical-forward-search
   *refinement-set-type*
   
   successor-set

   strips
   make-strips
   make-strips-schema
   nstrips
   make-nstrips
   *nstrips-noop*
   ncstrips
   make-ncstrips
   make-ncstrips-schema
   make-ncstrips-schemas
   for-all
   
   *random-refinement-ordering*
   
   high-level
   primitive
   )
  (:import-from 
   queue
   queue))
